diff --git a/cryptroot-script b/cryptroot-script
index 414f882..6aea503 100644
--- a/cryptroot-script
+++ b/cryptroot-script
@@ -222,11 +222,16 @@ setup_mapping()
 	udev_settle
 
 	# We've given up, but we'll let the user fix matters if they can
-	while [ ! -e "${cryptsource}" ]; do
+	if [ ! -e "${cryptsource}" ]; then
+		echo "  ALERT! ${cryptsource} does not exist."
 		echo "	Check cryptopts=source= bootarg: cat /proc/cmdline"
 		echo "	or missing modules, devices: cat /proc/modules; ls /dev"
-		panic -r "ALERT!  ${cryptsource} does not exist.  Dropping to a shell!"
-	done
+		panic -r "Dropping to a shell. Will skip ${cryptsource} if you can't fix."
+	fi
+
+	if [ ! -e "${cryptsource}" ]; then
+		return 1
+	fi
 
 	# Prepare commands
 	cryptopen="/sbin/cryptsetup -T 1"
